git-am.shon commit Sync with 1.7.6.6 (110c511)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, 2006 Junio C Hamano
   4
   5SUBDIRECTORY_OK=Yes
   6OPTIONS_KEEPDASHDASH=
   7OPTIONS_SPEC="\
   8git am [options] [(<mbox>|<Maildir>)...]
   9git am [options] (--resolved | --skip | --abort)
  10--
  11i,interactive   run interactively
  12b,binary*       (historical option -- no-op)
  133,3way          allow fall back on 3way merging if needed
  14q,quiet         be quiet
  15s,signoff       add a Signed-off-by line to the commit message
  16u,utf8          recode into utf8 (default)
  17k,keep          pass -k flag to git-mailinfo
  18keep-cr         pass --keep-cr flag to git-mailsplit for mbox format
  19no-keep-cr      do not pass --keep-cr flag to git-mailsplit independent of am.keepcr
  20c,scissors      strip everything before a scissors line
  21whitespace=     pass it through git-apply
  22ignore-space-change pass it through git-apply
  23ignore-whitespace pass it through git-apply
  24directory=      pass it through git-apply
  25exclude=        pass it through git-apply
  26C=              pass it through git-apply
  27p=              pass it through git-apply
  28patch-format=   format the patch(es) are in
  29reject          pass it through git-apply
  30resolvemsg=     override error message when patch failure occurs
  31continue        continue applying patches after resolving a conflict
  32r,resolved      synonyms for --continue
  33skip            skip the current patch
  34abort           restore the original branch and abort the patching operation.
  35committer-date-is-author-date    lie about committer date
  36ignore-date     use current timestamp for author date
  37rerere-autoupdate update the index with reused conflict resolution if possible
  38rebasing*       (internal use for git-rebase)"
  39
  40. git-sh-setup
  41. git-sh-i18n
  42prefix=$(git rev-parse --show-prefix)
  43set_reflog_action am
  44require_work_tree
  45cd_to_toplevel
  46
  47git var GIT_COMMITTER_IDENT >/dev/null ||
  48        die "$(gettext "You need to set your committer info first")"
  49
  50if git rev-parse --verify -q HEAD >/dev/null
  51then
  52        HAS_HEAD=yes
  53else
  54        HAS_HEAD=
  55fi
  56
  57cmdline="git am"
  58if test '' != "$interactive"
  59then
  60        cmdline="$cmdline -i"
  61fi
  62if test '' != "$threeway"
  63then
  64        cmdline="$cmdline -3"
  65fi
  66
  67sq () {
  68        git rev-parse --sq-quote "$@"
  69}
  70
  71stop_here () {
  72    echo "$1" >"$dotest/next"
  73    git rev-parse --verify -q HEAD >"$dotest/abort-safety"
  74    exit 1
  75}
  76
  77safe_to_abort () {
  78        if test -f "$dotest/dirtyindex"
  79        then
  80                return 1
  81        fi
  82
  83        if ! test -s "$dotest/abort-safety"
  84        then
  85                return 0
  86        fi
  87
  88        abort_safety=$(cat "$dotest/abort-safety")
  89        if test "z$(git rev-parse --verify -q HEAD)" = "z$abort_safety"
  90        then
  91                return 0
  92        fi
  93                gettextln "You seem to have moved HEAD since the last 'am' failure.
  94Not rewinding to ORIG_HEAD" >&2
  95        return 1
  96}
  97
  98stop_here_user_resolve () {
  99    if [ -n "$resolvemsg" ]; then
 100            printf '%s\n' "$resolvemsg"
 101            stop_here $1
 102    fi
 103    eval_gettextln "When you have resolved this problem run \"\$cmdline --resolved\".
 104If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
 105To restore the original branch and stop patching run \"\$cmdline --abort\"."
 106
 107    stop_here $1
 108}
 109
 110go_next () {
 111        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
 112                "$dotest/patch" "$dotest/info"
 113        echo "$next" >"$dotest/next"
 114        this=$next
 115}
 116
 117cannot_fallback () {
 118        echo "$1"
 119        gettextln "Cannot fall back to three-way merge."
 120        exit 1
 121}
 122
 123fall_back_3way () {
 124    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
 125
 126    rm -fr "$dotest"/patch-merge-*
 127    mkdir "$dotest/patch-merge-tmp-dir"
 128
 129    # First see if the patch records the index info that we can use.
 130    git apply --build-fake-ancestor "$dotest/patch-merge-tmp-index" \
 131        "$dotest/patch" &&
 132    GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 133    git write-tree >"$dotest/patch-merge-base+" ||
 134    cannot_fallback "$(gettext "Repository lacks necessary blobs to fall back on 3-way merge.")"
 135
 136    say Using index info to reconstruct a base tree...
 137    if GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
 138        git apply --cached <"$dotest/patch"
 139    then
 140        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
 141        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
 142    else
 143        cannot_fallback "$(gettext "Did you hand edit your patch?
 144It does not apply to blobs recorded in its index.")"
 145    fi
 146
 147    test -f "$dotest/patch-merge-index" &&
 148    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git write-tree) &&
 149    orig_tree=$(cat "$dotest/patch-merge-base") &&
 150    rm -fr "$dotest"/patch-merge-* || exit 1
 151
 152    say "$(gettext "Falling back to patching base and 3-way merge...")"
 153
 154    # This is not so wrong.  Depending on which base we picked,
 155    # orig_tree may be wildly different from ours, but his_tree
 156    # has the same set of wildly different changes in parts the
 157    # patch did not touch, so recursive ends up canceling them,
 158    # saying that we reverted all those changes.
 159
 160    eval GITHEAD_$his_tree='"$FIRSTLINE"'
 161    export GITHEAD_$his_tree
 162    if test -n "$GIT_QUIET"
 163    then
 164            GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
 165    fi
 166    git-merge-recursive $orig_tree -- HEAD $his_tree || {
 167            git rerere $allow_rerere_autoupdate
 168            echo Failed to merge in the changes.
 169            exit 1
 170    }
 171    unset GITHEAD_$his_tree
 172}
 173
 174clean_abort () {
 175        test $# = 0 || echo >&2 "$@"
 176        rm -fr "$dotest"
 177        exit 1
 178}
 179
 180patch_format=
 181
 182check_patch_format () {
 183        # early return if patch_format was set from the command line
 184        if test -n "$patch_format"
 185        then
 186                return 0
 187        fi
 188
 189        # we default to mbox format if input is from stdin and for
 190        # directories
 191        if test $# = 0 || test "x$1" = "x-" || test -d "$1"
 192        then
 193                patch_format=mbox
 194                return 0
 195        fi
 196
 197        # otherwise, check the first few non-blank lines of the first
 198        # patch to try to detect its format
 199        {
 200                # Start from first line containing non-whitespace
 201                l1=
 202                while test -z "$l1"
 203                do
 204                        read l1
 205                done
 206                read l2
 207                read l3
 208                case "$l1" in
 209                "From "* | "From: "*)
 210                        patch_format=mbox
 211                        ;;
 212                '# This series applies on GIT commit'*)
 213                        patch_format=stgit-series
 214                        ;;
 215                "# HG changeset patch")
 216                        patch_format=hg
 217                        ;;
 218                *)
 219                        # if the second line is empty and the third is
 220                        # a From, Author or Date entry, this is very
 221                        # likely an StGIT patch
 222                        case "$l2,$l3" in
 223                        ,"From: "* | ,"Author: "* | ,"Date: "*)
 224                                patch_format=stgit
 225                                ;;
 226                        *)
 227                                ;;
 228                        esac
 229                        ;;
 230                esac
 231                if test -z "$patch_format" &&
 232                        test -n "$l1" &&
 233                        test -n "$l2" &&
 234                        test -n "$l3"
 235                then
 236                        # This begins with three non-empty lines.  Is this a
 237                        # piece of e-mail a-la RFC2822?  Grab all the headers,
 238                        # discarding the indented remainder of folded lines,
 239                        # and see if it looks like that they all begin with the
 240                        # header field names...
 241                        tr -d '\015' <"$1" |
 242                        sed -n -e '/^$/q' -e '/^[       ]/d' -e p |
 243                        sane_egrep -v '^[!-9;-~]+:' >/dev/null ||
 244                        patch_format=mbox
 245                fi
 246        } < "$1" || clean_abort
 247}
 248
 249split_patches () {
 250        case "$patch_format" in
 251        mbox)
 252                if test -n "$rebasing" || test t = "$keepcr"
 253                then
 254                    keep_cr=--keep-cr
 255                else
 256                    keep_cr=
 257                fi
 258                git mailsplit -d"$prec" -o"$dotest" -b $keep_cr -- "$@" > "$dotest/last" ||
 259                clean_abort
 260                ;;
 261        stgit-series)
 262                if test $# -ne 1
 263                then
 264                        clean_abort "$(gettext "Only one StGIT patch series can be applied at once")"
 265                fi
 266                series_dir=`dirname "$1"`
 267                series_file="$1"
 268                shift
 269                {
 270                        set x
 271                        while read filename
 272                        do
 273                                set "$@" "$series_dir/$filename"
 274                        done
 275                        # remove the safety x
 276                        shift
 277                        # remove the arg coming from the first-line comment
 278                        shift
 279                } < "$series_file" || clean_abort
 280                # set the patch format appropriately
 281                patch_format=stgit
 282                # now handle the actual StGIT patches
 283                split_patches "$@"
 284                ;;
 285        stgit)
 286                this=0
 287                for stgit in "$@"
 288                do
 289                        this=`expr "$this" + 1`
 290                        msgnum=`printf "%0${prec}d" $this`
 291                        # Perl version of StGIT parse_patch. The first nonemptyline
 292                        # not starting with Author, From or Date is the
 293                        # subject, and the body starts with the next nonempty
 294                        # line not starting with Author, From or Date
 295                        perl -ne 'BEGIN { $subject = 0 }
 296                                if ($subject > 1) { print ; }
 297                                elsif (/^\s+$/) { next ; }
 298                                elsif (/^Author:/) { s/Author/From/ ; print ;}
 299                                elsif (/^(From|Date)/) { print ; }
 300                                elsif ($subject) {
 301                                        $subject = 2 ;
 302                                        print "\n" ;
 303                                        print ;
 304                                } else {
 305                                        print "Subject: ", $_ ;
 306                                        $subject = 1;
 307                                }
 308                        ' < "$stgit" > "$dotest/$msgnum" || clean_abort
 309                done
 310                echo "$this" > "$dotest/last"
 311                this=
 312                msgnum=
 313                ;;
 314        *)
 315                if test -n "$patch_format"
 316                then
 317                        clean_abort "$(eval_gettext "Patch format \$patch_format is not supported.")"
 318                else
 319                        clean_abort "$(gettext "Patch format detection failed.")"
 320                fi
 321                ;;
 322        esac
 323}
 324
 325prec=4
 326dotest="$GIT_DIR/rebase-apply"
 327sign= utf8=t keep= keepcr= skip= interactive= resolved= rebasing= abort=
 328resolvemsg= resume= scissors= no_inbody_headers=
 329git_apply_opt=
 330committer_date_is_author_date=
 331ignore_date=
 332allow_rerere_autoupdate=
 333
 334if test "$(git config --bool --get am.keepcr)" = true
 335then
 336    keepcr=t
 337fi
 338
 339while test $# != 0
 340do
 341        case "$1" in
 342        -i|--interactive)
 343                interactive=t ;;
 344        -b|--binary)
 345                : ;;
 346        -3|--3way)
 347                threeway=t ;;
 348        -s|--signoff)
 349                sign=t ;;
 350        -u|--utf8)
 351                utf8=t ;; # this is now default
 352        --no-utf8)
 353                utf8= ;;
 354        -k|--keep)
 355                keep=t ;;
 356        -c|--scissors)
 357                scissors=t ;;
 358        --no-scissors)
 359                scissors=f ;;
 360        -r|--resolved|--continue)
 361                resolved=t ;;
 362        --skip)
 363                skip=t ;;
 364        --abort)
 365                abort=t ;;
 366        --rebasing)
 367                rebasing=t threeway=t keep=t scissors=f no_inbody_headers=t ;;
 368        -d|--dotest)
 369                die "$(gettext "-d option is no longer supported.  Do not use.")"
 370                ;;
 371        --resolvemsg)
 372                shift; resolvemsg=$1 ;;
 373        --whitespace|--directory|--exclude)
 374                git_apply_opt="$git_apply_opt $(sq "$1=$2")"; shift ;;
 375        -C|-p)
 376                git_apply_opt="$git_apply_opt $(sq "$1$2")"; shift ;;
 377        --patch-format)
 378                shift ; patch_format="$1" ;;
 379        --reject|--ignore-whitespace|--ignore-space-change)
 380                git_apply_opt="$git_apply_opt $1" ;;
 381        --committer-date-is-author-date)
 382                committer_date_is_author_date=t ;;
 383        --ignore-date)
 384                ignore_date=t ;;
 385        --rerere-autoupdate|--no-rerere-autoupdate)
 386                allow_rerere_autoupdate="$1" ;;
 387        -q|--quiet)
 388                GIT_QUIET=t ;;
 389        --keep-cr)
 390                keepcr=t ;;
 391        --no-keep-cr)
 392                keepcr=f ;;
 393        --)
 394                shift; break ;;
 395        *)
 396                usage ;;
 397        esac
 398        shift
 399done
 400
 401# If the dotest directory exists, but we have finished applying all the
 402# patches in them, clear it out.
 403if test -d "$dotest" &&
 404   last=$(cat "$dotest/last") &&
 405   next=$(cat "$dotest/next") &&
 406   test $# != 0 &&
 407   test "$next" -gt "$last"
 408then
 409   rm -fr "$dotest"
 410fi
 411
 412if test -d "$dotest"
 413then
 414        case "$#,$skip$resolved$abort" in
 415        0,*t*)
 416                # Explicit resume command and we do not have file, so
 417                # we are happy.
 418                : ;;
 419        0,)
 420                # No file input but without resume parameters; catch
 421                # user error to feed us a patch from standard input
 422                # when there is already $dotest.  This is somewhat
 423                # unreliable -- stdin could be /dev/null for example
 424                # and the caller did not intend to feed us a patch but
 425                # wanted to continue unattended.
 426                test -t 0
 427                ;;
 428        *)
 429                false
 430                ;;
 431        esac ||
 432        die "$(eval_gettext "previous rebase directory \$dotest still exists but mbox given.")"
 433        resume=yes
 434
 435        case "$skip,$abort" in
 436        t,t)
 437                die "$(gettext "Please make up your mind. --skip or --abort?")"
 438                ;;
 439        t,)
 440                git rerere clear
 441                git read-tree --reset -u HEAD HEAD
 442                orig_head=$(cat "$GIT_DIR/ORIG_HEAD")
 443                git reset HEAD
 444                git update-ref ORIG_HEAD $orig_head
 445                ;;
 446        ,t)
 447                if test -f "$dotest/rebasing"
 448                then
 449                        exec git rebase --abort
 450                fi
 451                git rerere clear
 452                if safe_to_abort
 453                then
 454                        git read-tree --reset -u HEAD ORIG_HEAD
 455                        git reset ORIG_HEAD
 456                fi
 457                rm -fr "$dotest"
 458                exit ;;
 459        esac
 460        rm -f "$dotest/dirtyindex"
 461else
 462        # Make sure we are not given --skip, --resolved, nor --abort
 463        test "$skip$resolved$abort" = "" ||
 464                die "$(gettext "Resolve operation not in progress, we are not resuming.")"
 465
 466        # Start afresh.
 467        mkdir -p "$dotest" || exit
 468
 469        if test -n "$prefix" && test $# != 0
 470        then
 471                first=t
 472                for arg
 473                do
 474                        test -n "$first" && {
 475                                set x
 476                                first=
 477                        }
 478                        if is_absolute_path "$arg"
 479                        then
 480                                set "$@" "$arg"
 481                        else
 482                                set "$@" "$prefix$arg"
 483                        fi
 484                done
 485                shift
 486        fi
 487
 488        check_patch_format "$@"
 489
 490        split_patches "$@"
 491
 492        # -i can and must be given when resuming; everything
 493        # else is kept
 494        echo " $git_apply_opt" >"$dotest/apply-opt"
 495        echo "$threeway" >"$dotest/threeway"
 496        echo "$sign" >"$dotest/sign"
 497        echo "$utf8" >"$dotest/utf8"
 498        echo "$keep" >"$dotest/keep"
 499        echo "$scissors" >"$dotest/scissors"
 500        echo "$no_inbody_headers" >"$dotest/no_inbody_headers"
 501        echo "$GIT_QUIET" >"$dotest/quiet"
 502        echo 1 >"$dotest/next"
 503        if test -n "$rebasing"
 504        then
 505                : >"$dotest/rebasing"
 506        else
 507                : >"$dotest/applying"
 508                if test -n "$HAS_HEAD"
 509                then
 510                        git update-ref ORIG_HEAD HEAD
 511                else
 512                        git update-ref -d ORIG_HEAD >/dev/null 2>&1
 513                fi
 514        fi
 515fi
 516
 517git update-index -q --refresh
 518
 519case "$resolved" in
 520'')
 521        case "$HAS_HEAD" in
 522        '')
 523                files=$(git ls-files) ;;
 524        ?*)
 525                files=$(git diff-index --cached --name-only HEAD --) ;;
 526        esac || exit
 527        if test "$files"
 528        then
 529                test -n "$HAS_HEAD" && : >"$dotest/dirtyindex"
 530                die "$(eval_gettext "Dirty index: cannot apply patches (dirty: \$files)")"
 531        fi
 532esac
 533
 534if test "$(cat "$dotest/utf8")" = t
 535then
 536        utf8=-u
 537else
 538        utf8=-n
 539fi
 540if test "$(cat "$dotest/keep")" = t
 541then
 542        keep=-k
 543fi
 544case "$(cat "$dotest/scissors")" in
 545t)
 546        scissors=--scissors ;;
 547f)
 548        scissors=--no-scissors ;;
 549esac
 550if test "$(cat "$dotest/no_inbody_headers")" = t
 551then
 552        no_inbody_headers=--no-inbody-headers
 553else
 554        no_inbody_headers=
 555fi
 556if test "$(cat "$dotest/quiet")" = t
 557then
 558        GIT_QUIET=t
 559fi
 560if test "$(cat "$dotest/threeway")" = t
 561then
 562        threeway=t
 563fi
 564git_apply_opt=$(cat "$dotest/apply-opt")
 565if test "$(cat "$dotest/sign")" = t
 566then
 567        SIGNOFF=`git var GIT_COMMITTER_IDENT | sed -e '
 568                        s/>.*/>/
 569                        s/^/Signed-off-by: /'
 570                `
 571else
 572        SIGNOFF=
 573fi
 574
 575last=`cat "$dotest/last"`
 576this=`cat "$dotest/next"`
 577if test "$skip" = t
 578then
 579        this=`expr "$this" + 1`
 580        resume=
 581fi
 582
 583while test "$this" -le "$last"
 584do
 585        msgnum=`printf "%0${prec}d" $this`
 586        next=`expr "$this" + 1`
 587        test -f "$dotest/$msgnum" || {
 588                resume=
 589                go_next
 590                continue
 591        }
 592
 593        # If we are not resuming, parse and extract the patch information
 594        # into separate files:
 595        #  - info records the authorship and title
 596        #  - msg is the rest of commit log message
 597        #  - patch is the patch body.
 598        #
 599        # When we are resuming, these files are either already prepared
 600        # by the user, or the user can tell us to do so by --resolved flag.
 601        case "$resume" in
 602        '')
 603                git mailinfo $keep $no_inbody_headers $scissors $utf8 "$dotest/msg" "$dotest/patch" \
 604                        <"$dotest/$msgnum" >"$dotest/info" ||
 605                        stop_here $this
 606
 607                # skip pine's internal folder data
 608                sane_grep '^Author: Mail System Internal Data$' \
 609                        <"$dotest"/info >/dev/null &&
 610                        go_next && continue
 611
 612                test -s "$dotest/patch" || {
 613                        eval_gettextln "Patch is empty.  Was it split wrong?
 614If you would prefer to skip this patch, instead run \"\$cmdline --skip\".
 615To restore the original branch and stop patching run \"\$cmdline --abort\"."
 616                        stop_here $this
 617                }
 618                rm -f "$dotest/original-commit" "$dotest/author-script"
 619                if test -f "$dotest/rebasing" &&
 620                        commit=$(sed -e 's/^From \([0-9a-f]*\) .*/\1/' \
 621                                -e q "$dotest/$msgnum") &&
 622                        test "$(git cat-file -t "$commit")" = commit
 623                then
 624                        git cat-file commit "$commit" |
 625                        sed -e '1,/^$/d' >"$dotest/msg-clean"
 626                        echo "$commit" > "$dotest/original-commit"
 627                        get_author_ident_from_commit "$commit" > "$dotest/author-script"
 628                else
 629                        {
 630                                sed -n '/^Subject/ s/Subject: //p' "$dotest/info"
 631                                echo
 632                                cat "$dotest/msg"
 633                        } |
 634                        git stripspace > "$dotest/msg-clean"
 635                fi
 636                ;;
 637        esac
 638
 639        if test -f "$dotest/author-script"
 640        then
 641                eval $(cat "$dotest/author-script")
 642        else
 643                GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 644                GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 645                GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 646        fi
 647
 648        if test -z "$GIT_AUTHOR_EMAIL"
 649        then
 650                gettextln "Patch does not have a valid e-mail address."
 651                stop_here $this
 652        fi
 653
 654        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 655
 656        case "$resume" in
 657        '')
 658            if test '' != "$SIGNOFF"
 659            then
 660                LAST_SIGNED_OFF_BY=`
 661                    sed -ne '/^Signed-off-by: /p' \
 662                    "$dotest/msg-clean" |
 663                    sed -ne '$p'
 664                `
 665                ADD_SIGNOFF=`
 666                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 667                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 668                    echo "$SIGNOFF"
 669                }`
 670            else
 671                ADD_SIGNOFF=
 672            fi
 673            {
 674                if test -s "$dotest/msg-clean"
 675                then
 676                        cat "$dotest/msg-clean"
 677                fi
 678                if test '' != "$ADD_SIGNOFF"
 679                then
 680                        echo "$ADD_SIGNOFF"
 681                fi
 682            } >"$dotest/final-commit"
 683            ;;
 684        *)
 685                case "$resolved$interactive" in
 686                tt)
 687                        # This is used only for interactive view option.
 688                        git diff-index -p --cached HEAD -- >"$dotest/patch"
 689                        ;;
 690                esac
 691        esac
 692
 693        resume=
 694        if test "$interactive" = t
 695        then
 696            test -t 0 ||
 697            die "$(gettext "cannot be interactive without stdin connected to a terminal.")"
 698            action=again
 699            while test "$action" = again
 700            do
 701                gettextln "Commit Body is:"
 702                echo "--------------------------"
 703                cat "$dotest/final-commit"
 704                echo "--------------------------"
 705                # TRANSLATORS: Make sure to include [y], [n], [e], [v] and [a]
 706                # in your translation. The program will only accept English
 707                # input at this point.
 708                gettext "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 709                read reply
 710                case "$reply" in
 711                [yY]*) action=yes ;;
 712                [aA]*) action=yes interactive= ;;
 713                [nN]*) action=skip ;;
 714                [eE]*) git_editor "$dotest/final-commit"
 715                       action=again ;;
 716                [vV]*) action=again
 717                       git_pager "$dotest/patch" ;;
 718                *)     action=again ;;
 719                esac
 720            done
 721        else
 722            action=yes
 723        fi
 724
 725        if test -f "$dotest/final-commit"
 726        then
 727                FIRSTLINE=$(sed 1q "$dotest/final-commit")
 728        else
 729                FIRSTLINE=""
 730        fi
 731
 732        if test $action = skip
 733        then
 734                go_next
 735                continue
 736        fi
 737
 738        if test -x "$GIT_DIR"/hooks/applypatch-msg
 739        then
 740                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 741                stop_here $this
 742        fi
 743
 744        say "$(eval_gettext "Applying: \$FIRSTLINE")"
 745
 746        case "$resolved" in
 747        '')
 748                # When we are allowed to fall back to 3-way later, don't give
 749                # false errors during the initial attempt.
 750                squelch=
 751                if test "$threeway" = t
 752                then
 753                        squelch='>/dev/null 2>&1 '
 754                fi
 755                eval "git apply $squelch$git_apply_opt"' --index "$dotest/patch"'
 756                apply_status=$?
 757                ;;
 758        t)
 759                # Resolved means the user did all the hard work, and
 760                # we do not have to do any patch application.  Just
 761                # trust what the user has in the index file and the
 762                # working tree.
 763                resolved=
 764                git diff-index --quiet --cached HEAD -- && {
 765                        gettextln "No changes - did you forget to use 'git add'?
 766If there is nothing left to stage, chances are that something else
 767already introduced the same changes; you might want to skip this patch."
 768                        stop_here_user_resolve $this
 769                }
 770                unmerged=$(git ls-files -u)
 771                if test -n "$unmerged"
 772                then
 773                        gettextln "You still have unmerged paths in your index
 774did you forget to use 'git add'?"
 775                        stop_here_user_resolve $this
 776                fi
 777                apply_status=0
 778                git rerere
 779                ;;
 780        esac
 781
 782        if test $apply_status != 0 && test "$threeway" = t
 783        then
 784                if (fall_back_3way)
 785                then
 786                    # Applying the patch to an earlier tree and merging the
 787                    # result may have produced the same tree as ours.
 788                    git diff-index --quiet --cached HEAD -- && {
 789                        say "$(gettext "No changes -- Patch already applied.")"
 790                        go_next
 791                        continue
 792                    }
 793                    # clear apply_status -- we have successfully merged.
 794                    apply_status=0
 795                fi
 796        fi
 797        if test $apply_status != 0
 798        then
 799                eval_gettextln 'Patch failed at $msgnum $FIRSTLINE'
 800                stop_here_user_resolve $this
 801        fi
 802
 803        if test -x "$GIT_DIR"/hooks/pre-applypatch
 804        then
 805                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 806        fi
 807
 808        tree=$(git write-tree) &&
 809        commit=$(
 810                if test -n "$ignore_date"
 811                then
 812                        GIT_AUTHOR_DATE=
 813                fi
 814                parent=$(git rev-parse --verify -q HEAD) ||
 815                say >&2 "$(gettext "applying to an empty history")"
 816
 817                if test -n "$committer_date_is_author_date"
 818                then
 819                        GIT_COMMITTER_DATE="$GIT_AUTHOR_DATE"
 820                        export GIT_COMMITTER_DATE
 821                fi &&
 822                git commit-tree $tree ${parent:+-p} $parent <"$dotest/final-commit"
 823        ) &&
 824        git update-ref -m "$GIT_REFLOG_ACTION: $FIRSTLINE" HEAD $commit $parent ||
 825        stop_here $this
 826
 827        if test -f "$dotest/original-commit"; then
 828                echo "$(cat "$dotest/original-commit") $commit" >> "$dotest/rewritten"
 829        fi
 830
 831        if test -x "$GIT_DIR"/hooks/post-applypatch
 832        then
 833                "$GIT_DIR"/hooks/post-applypatch
 834        fi
 835
 836        go_next
 837done
 838
 839if test -s "$dotest"/rewritten; then
 840    git notes copy --for-rewrite=rebase < "$dotest"/rewritten
 841    if test -x "$GIT_DIR"/hooks/post-rewrite; then
 842        "$GIT_DIR"/hooks/post-rewrite rebase < "$dotest"/rewritten
 843    fi
 844fi
 845
 846rm -fr "$dotest"
 847git gc --auto